#Build order:
#0.coeurl
#0.lmdbxx
#0.mpark-variant
#0.olm
#0.qt-jdenticon
#1.mtxclient (BR coeurl, olm)
#2-nheko

%global _smp_build_ncpus 2

Name:           nheko
Version:        0.12.0
Release:        %mkrel 6
Summary:        Desktop client for the Matrix protocol
# Main source - GPLv3+
# cpp-httplib - bundled - MIT
# blurhash - bundled - Boost
License:        GPLv3+ and MIT and Boost
Group:          Networking/Instant messaging
URL:            https://github.com/Nheko-Reborn/nheko
#from https://github.com/Nheko-Reborn/nheko/archive/refs/tags/v%%{version}.tar.gz
Source0:        https://github.com/Nheko-Reborn/nheko/archive/v%{version}/nheko-%{version}.tar.gz
Patch1:         nheko-0_12_0-fix-fmt11-build-error1.patch

BuildRequires:  cmake
BuildRequires:  cmake(Boost)
BuildRequires:  cmake(mpark_variant)
BuildRequires:  cmake(MatrixClient) >= 0.10.0
BuildRequires:  cmake(Olm)
BuildRequires:  cmake(Qt6Concurrent)
BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6DBus)
BuildRequires:  cmake(Qt6Keychain) >= 0.12.0
BuildRequires:  cmake(Qt6LinguistTools)
BuildRequires:  cmake(Qt6Multimedia)
BuildRequires:  cmake(Qt6Network)
BuildRequires:  cmake(Qt6Qml)
BuildRequires:  cmake(Qt6QuickControls2)
BuildRequires:  cmake(Qt6QuickWidgets)
BuildRequires:  cmake(Qt6Svg)
BuildRequires:  cmake(Qt6Widgets)
BuildRequires:  cmake(KDSingleApplication-qt6)
BuildRequires:  cmake(nlohmann_json) >= 3.2.0
BuildRequires:  cmake(spdlog) >= 1.0.0
BuildRequires:  pkgconfig(coeurl) >= 0.3.0
BuildRequires:  pkgconfig(gstreamer-1.0) >= 1.18.0
BuildRequires:  pkgconfig(gstreamer-app-1.0) >= 1.18.0
BuildRequires:  pkgconfig(gstreamer-audio-1.0) >= 1.18.0
BuildRequires:  pkgconfig(gstreamer-base-1.0) >= 1.18.0
BuildRequires:  pkgconfig(gstreamer-sdp-1.0) >= 1.18.0
BuildRequires:  pkgconfig(gstreamer-video-1.0) >= 1.18.0
BuildRequires:  pkgconfig(gstreamer-webrtc-1.0) >= 1.18.0
BuildRequires:  pkgconfig(libcmark) >= 0.29.0
BuildRequires:  pkgconfig(libcrypto)
BuildRequires:  pkgconfig(libevent)
BuildRequires:  pkgconfig(lmdb)
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig(re2)
BuildRequires:  pkgconfig(xcb)
BuildRequires:  pkgconfig(xcb-ewmh)
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(gnome-keyring-1)
BuildRequires:  asciidoc
BuildRequires:  desktop-file-utils
BuildRequires:  pkgconfig(appstream-glib)
BuildRequires:  pkgconfig(libsecret-1)
BuildRequires:  lmdbxx-devel >= 1.0.0
BuildRequires:  ninja

Requires:       hicolor-icon-theme
Requires:       qt-jdenticon%{?_isa}
Requires:       qtdeclarative6%{?_isa}
Requires:       qtmultimedia6%{?_isa}
#Virtual require needed by the application
Requires:       secret-manager
# gstreamer
Requires:       gstreamer1(element-nicesrc)%{?_arch_tag_suffix}
Requires:       gstreamer1(element-nicesink)%{?_arch_tag_suffix}
Requires:       gstreamer1(element-vp8enc)%{?_arch_tag_suffix}
Requires:       gstreamer1(element-pipewiresrc)%{?_arch_tag_suffix}

Recommends:     google-noto-emoji-color-fonts

Obsoletes:      nheko-zsh-completion < 0.12.0

%description
The motivation behind the project is to provide a native desktop app for Matrix
that feels more like a mainstream chat app (Element, Telegram etc.) and less
like an IRC client.

%prep
%autosetup -p1

%build
%cmake -G Ninja \
       -DHUNTER_ENABLED=OFF

%cmake_build

%install
%cmake_install

%check
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/%{name}.appdata.xml

%files
%doc README.md CHANGELOG.md
%license COPYING
%{_bindir}/nheko
%{_metainfodir}/nheko.appdata.xml
%{_datadir}/applications/nheko.desktop
%{_datadir}/icons/hicolor/*/apps/nheko.*
%{_mandir}/man1/nheko.1.*
%{_datadir}/zsh/site-functions/_nheko


%changelog
* Fri Jun 13 2025 wally <wally> 0.12.0-6.mga10
+ Revision: 2190829
- rebuild for kdsingleapplication 1.2.0

* Fri Jan 31 2025 daviddavid <daviddavid> 0.12.0-5.mga10
+ Revision: 2143753
- rebuild for new spdlog 1.15.0

* Wed Oct 02 2024 daviddavid <daviddavid> 0.12.0-4.mga10
+ Revision: 2102506
- backport upstream patch to fix build with fmt 11.x
- rebuild for new fmt 11.0.2

* Thu Aug 22 2024 daviddavid <daviddavid> 0.12.0-3.mga10
+ Revision: 2087405
- rebuild for new cmark 0.31.1

* Wed Jun 19 2024 wally <wally> 0.12.0-2.mga10
+ Revision: 2075306
- require qtdeclarative6

* Mon Jun 17 2024 wally <wally> 0.12.0-1.mga10
+ Revision: 2074668
- new version 0.12.0
- switch to Qt6
- drop separate zsh-completion sub pkg

* Wed May 08 2024 wally <wally> 0.11.3-8.mga10
+ Revision: 2062882
- rebuild for spdlog 1.14.1
- rebuild for re2 20240401
+ papoteur <papoteur>
- remove qca-qt5 requirement, now managed in kwallet
- add requirement for secret-manager

* Sat Jan 20 2024 squidf <squidf> 0.11.3-5.mga10
+ Revision: 2032389
- Rebuild with olm 3.2.16

* Thu Sep 07 2023 squidf <squidf> 0.11.3-4.mga10
+ Revision: 1985016
- Rebuild for BR rebuilt with new spdlog
- Update olm to 3.2.15
+ daviddavid <daviddavid>
- rebuild for new spdlog

* Tue Apr 25 2023 squidf <squidf> 0.11.3-3.mga9
+ Revision: 1954918
+ rebuild (emptylog)

* Tue Apr 25 2023 squidf <squidf> 0.11.3-2.mga9
+ Revision: 1954910
- Rebuild for mtxclient 0.9.2

* Sun Apr 23 2023 squidf <squidf> 0.11.3-1.mga9
+ Revision: 1954622
- Add missing dependency
- New version: 0.11.3

* Sun Feb 19 2023 daviddavid <daviddavid> 0.11.1-3.mga9
+ Revision: 1944157
- rebuild for new cmark

* Mon Jan 16 2023 squidf <squidf> 0.11.1-2.mga9
+ Revision: 1933704
- Recommend emojis font

* Mon Jan 16 2023 squidf <squidf> 0.11.1-1.mga9
+ Revision: 1933699
- New version: 0.11.1

* Sat Jan 14 2023 squidf <squidf> 0.11.0-1.mga9
+ Revision: 1932887
- New version: 0.11.0

* Fri Dec 23 2022 squidf <squidf> 0.10.2-1.1.mga9
+ Revision: 1926145
- Fix zsh package group
- First build for Mageia

